/*
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * THIS FILE WAS GENERATED BY codergen. EDIT WITH CARE.
 */
package com.android.tools.idea.editors.gfxtrace.service.path;

import com.android.tools.rpclib.schema.*;
import com.android.tools.rpclib.binary.*;
import org.jetbrains.annotations.NotNull;

import java.io.IOException;

public final class ReportPath extends Path {
  @Override
  public String getSegmentString() {
    return "Report";
  }

  @Override
  public Path getParent() {
    return myCapture;
  }

  //<<<Start:Java.ClassBody:1>>>
  private CapturePath myCapture;
  private DevicePath myDevice;

  // Constructs a default-initialized {@link ReportPath}.
  public ReportPath() {}


  public CapturePath getCapture() {
    return myCapture;
  }

  public ReportPath setCapture(CapturePath v) {
    myCapture = v;
    return this;
  }

  public DevicePath getDevice() {
    return myDevice;
  }

  public ReportPath setDevice(DevicePath v) {
    myDevice = v;
    return this;
  }

  @Override @NotNull
  public BinaryClass klass() { return Klass.INSTANCE; }


  private static final Entity ENTITY = new Entity("path", "Report", "", "");

  static {
    ENTITY.setFields(new Field[]{
      new Field("Capture", new Pointer(new Struct(CapturePath.Klass.INSTANCE.entity()))),
      new Field("Device", new Pointer(new Struct(DevicePath.Klass.INSTANCE.entity()))),
    });
    Namespace.register(Klass.INSTANCE);
  }
  public static void register() {}
  //<<<End:Java.ClassBody:1>>>
  public enum Klass implements BinaryClass {
    //<<<Start:Java.KlassBody:2>>>
    INSTANCE;

    @Override @NotNull
    public Entity entity() { return ENTITY; }

    @Override @NotNull
    public BinaryObject create() { return new ReportPath(); }

    @Override
    public void encode(@NotNull Encoder e, BinaryObject obj) throws IOException {
      ReportPath o = (ReportPath)obj;
      e.object(o.myCapture);
      e.object(o.myDevice);
    }

    @Override
    public void decode(@NotNull Decoder d, BinaryObject obj) throws IOException {
      ReportPath o = (ReportPath)obj;
      o.myCapture = (CapturePath)d.object();
      o.myDevice = (DevicePath)d.object();
    }
    //<<<End:Java.KlassBody:2>>>
  }
}
