/*
 * Copyright (C) 2014 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.android.tools.idea.gradle.messages;

import com.intellij.pom.Navigatable;
import org.jetbrains.annotations.NotNull;

/**
* Base class for implementations of {@link com.intellij.pom.Navigatable}.
 */
public abstract class AbstractNavigatable implements Navigatable {
  @NotNull public static final Navigatable NOT_NAVIGATABLE = new AbstractNavigatable() {};

  @Override
  public void navigate(boolean requestFocus) {}

  @Override
  public boolean canNavigate() {
    return false;
  }

  @Override
  public boolean canNavigateToSource() {
    return false;
  }
}
