/*
 * Copyright 2000-2009 JetBrains s.r.o.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.intellij.diagnostic;

import com.intellij.openapi.actionSystem.AnActionEvent;
import com.intellij.openapi.project.DumbAwareAction;

@SuppressWarnings({"HardCodedStringLiteral"})
public class DropAnOutOfMemoryErrorAction extends DumbAwareAction {
  public DropAnOutOfMemoryErrorAction() {
    super ("Drop an OutOfMemoryError");
  }

  public void actionPerformed(AnActionEvent e) {
    Object[] array = new Object[Integer.MAX_VALUE];
    for (int i = 0; i < array.length; i++) {
      array[i] = new Object[Integer.MAX_VALUE];
    }
    throw new OutOfMemoryError();
  }
}